use clap::{Parser, Subcommand};
use hencelisp::*;
use std::fs;

#[derive(Debug, Parser)]
#[clap(author, version, about, long_about = None)]
struct Cli {
    #[clap(subcommand)]
    commands: Commands,
}

#[derive(Debug, Subcommand)]
enum Commands {
    #[clap(about = "Lexes source code and outputs tokens")]
    Lex {
        #[clap(value_parser)]
        src: String,
    },
}

fn main() {
    let args = Cli::parse();
    match args.commands {
        Commands::Lex { src } => {
            let source = fs::read_to_string(src).unwrap();
            let tokens = lexer::lex(source).unwrap();
            dbg!(tokens);
        }
    }
}
